// Выведение данных матричной клавиатуры на дисплей

#include <Keypad.h> // библиотека клавиатуры  
#include <LiquidCrystal_I2C.h> // библиотека дисплея  
  
const byte ROWS = 4; // четыре ряда  
const byte COLS = 4; // четыре колонки  
// определение значений каждой кнопки  
char keys[ROWS][COLS] = {  
  {'1','2','3','A'},  
  {'4','5','6','B'},  
  {'7','8','9','C'},  
  {'*','0','#','D'}  
};  
byte rowPins[ROWS] = {11, 10, 9, 8}; // пины рядов   
byte colPins[COLS] = {7, 6, 5, 4}; // пины колонок  
// определение клавиатуры как матрицы 4х4  
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );  
// определение адреса дисплея  
LiquidCrystal_I2C lcd(0x3f, 16, 2);    
  
void setup(){  
    
  lcd.begin(); // включение дисплея  
  lcd.backlight(); // включение подсветки  
  lcd.setCursor(0, 0); // курсор в начале первой строки  
  lcd.print("Hello, world!"); // фраза в первой строке  
  delay(2000); // задержка 2 секунды  
  lcd.setCursor(0, 1); // курсор в начале второй строки  
  lcd.print("I'm alive!!!"); // отображение фразы во второй строке  
  delay(2000); // задержка 2 секунды  
  lcd.clear(); // очистка дисплея  
}  
    
void loop(){  
  // выведение значения, которое привязано к кнопке, при нажатии в монитор порта  
  char key = keypad.getKey();  
  if (key){  
    Serial.println(key); // выведение данных в монитор порта  
    lcd.print(key); // выведение данных на дисплей  
    delay(500); // задержка 0.5 секунды  
    lcd.clear(); // очистка дисплея  
  }  
}  
